/**********************************************************
 * This file has been automatically created by "typemaker2"
 * from the file "jobqueue.xml".
 * Please do not edit this file, all changes will be lost.
 * Better edit the mentioned source file instead.
 **********************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include "./jobqueue_p.h"

#include <gwenhywfar/misc.h>
#include <gwenhywfar/debug.h>

/* code headers */

/* macro functions */
GWEN_LIST_FUNCTIONS(AB_JOBQUEUE, AB_JobQueue)
GWEN_INHERIT_FUNCTIONS(AB_JOBQUEUE)


AB_JOBQUEUE *AB_JobQueue_new(void) {
  AB_JOBQUEUE *p_struct;

  GWEN_NEW_OBJECT(AB_JOBQUEUE, p_struct)
  p_struct->_refCount=1;
  GWEN_INHERIT_INIT(AB_JOBQUEUE, p_struct)
  GWEN_LIST_INIT(AB_JOBQUEUE, p_struct)
  /* members */
  p_struct->jobType=0;
  p_struct->transactionList=AB_Transaction_List2_new();
  /* virtual functions */

  return p_struct;
}

void AB_JobQueue_free(AB_JOBQUEUE *p_struct) {
  if (p_struct) {
  assert(p_struct->_refCount);
  if (p_struct->_refCount==1) {
    GWEN_INHERIT_FINI(AB_JOBQUEUE, p_struct)
    GWEN_LIST_FINI(AB_JOBQUEUE, p_struct)
  /* members */
    AB_Transaction_List2_free(p_struct->transactionList); p_struct->transactionList=NULL;
    p_struct->_refCount=0;
    GWEN_FREE_OBJECT(p_struct);
  }
  else
    p_struct->_refCount--;
  }
}

void AB_JobQueue_Attach(AB_JOBQUEUE *p_struct) {
  assert(p_struct);
  assert(p_struct->_refCount);
  p_struct->_refCount++;
}

AB_JOBQUEUE *AB_JobQueue_dup(const AB_JOBQUEUE *p_src) {
  AB_JOBQUEUE *p_struct;

  assert(p_src);
  p_struct=AB_JobQueue_new();
  /* member "jobType" */
    p_struct->jobType=p_src->jobType;


  /* member "transactionList" */
  if (p_struct->transactionList) {
    AB_Transaction_List2_free(p_struct->transactionList); p_struct->transactionList=NULL;
  }
  if (p_src->transactionList) {
    p_struct->transactionList=AB_Transaction_List2_dup(p_src->transactionList);
  }


  return p_struct;
}

int AB_JobQueue_GetJobType(const AB_JOBQUEUE *p_struct){
  assert(p_struct);
  return p_struct->jobType;
}

AB_TRANSACTION_LIST2 *AB_JobQueue_GetTransactionList(const AB_JOBQUEUE *p_struct){
  assert(p_struct);
  return p_struct->transactionList;
}

void AB_JobQueue_SetJobType(AB_JOBQUEUE *p_struct, int p_src){
  assert(p_struct);
  p_struct->jobType=p_src;
}

void AB_JobQueue_SetTransactionList(AB_JOBQUEUE *p_struct, AB_TRANSACTION_LIST2 *p_src){
  assert(p_struct);
  if (p_struct->transactionList) {
    AB_Transaction_List2_free(p_struct->transactionList); p_struct->transactionList=NULL;
  }
  p_struct->transactionList=p_src;
}

AB_JOBQUEUE_LIST *AB_JobQueue_List_dup(const AB_JOBQUEUE_LIST *p_src) {
  AB_JOBQUEUE_LIST *p_dest;
  AB_JOBQUEUE *p_elem;

  assert(p_src);
  p_dest=AB_JobQueue_List_new();
  p_elem=AB_JobQueue_List_First(p_src);
  while(p_elem) {
    AB_JOBQUEUE *p_cpy;

    p_cpy=AB_JobQueue_dup(p_elem);
    AB_JobQueue_List_Add(p_cpy, p_dest);
    p_elem=AB_JobQueue_List_Next(p_elem);
  }

  return p_dest;
}

AB_JOBQUEUE *AB_JobQueue_List_GetByJobType(const AB_JOBQUEUE_LIST *p_list, int p_cmp){
  AB_JOBQUEUE *p_struct;

  assert(p_list);
  p_struct = AB_JobQueue_List_First(p_list);
  while(p_struct) {
    int p_rv;

    if (p_struct->jobType==p_cmp) p_rv=0; else if (p_cmp<p_struct->jobType) p_rv=-1; else p_rv=1;
    if (p_rv == 0)
      return p_struct;
    p_struct = AB_JobQueue_List_Next(p_struct);
  }
  return NULL;
}

void AB_JobQueue_AddTransaction(AB_JOBQUEUE *aq, AB_TRANSACTION *t) { if (aq->transactionList==NULL) aq->transactionList=AB_Transaction_List2_new(); AB_Transaction_List2_PushBack(aq->transactionList, t); }
AB_TRANSACTION *AB_JobQueue_GetFirstTransaction(const AB_JOBQUEUE *jq) { if (jq->transactionList) return AB_Transaction_List2_GetFront(jq->transactionList); return NULL; }

/* code headers */

